package org.wfc.omada.api.organization.model;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModelProperty;

import javax.validation.Valid;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * SiteTemplateSummaryVo
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.SpringCodegen", date = "2024-12-04T11:17:18.430+08:00[Asia/Shanghai]")

public class SiteTemplateSummaryVo   {
  @JsonProperty("id")
  private String id;

  @JsonProperty("omadacId")
  private String omadacId;

  @JsonProperty("name")
  private String name;

  @JsonProperty("status")
  private Integer status;

  @JsonProperty("bindSiteNum")
  private Long bindSiteNum;

  @JsonProperty("category")
  private String category;

  @JsonProperty("settings")
  @Valid
  private List<String> settings = null;

  public SiteTemplateSummaryVo id(String id) {
    this.id = id;
    return this;
  }

  /**
   * Site Template ID
   * @return id
  */
  @ApiModelProperty(value = "Site Template ID")


  public String getId() {
    return id;
  }

  public void setId(String id) {
    this.id = id;
  }

  public SiteTemplateSummaryVo omadacId(String omadacId) {
    this.omadacId = omadacId;
    return this;
  }

  /**
   * Omada ID
   * @return omadacId
  */
  @ApiModelProperty(value = "Omada ID")


  public String getOmadacId() {
    return omadacId;
  }

  public void setOmadacId(String omadacId) {
    this.omadacId = omadacId;
  }

  public SiteTemplateSummaryVo name(String name) {
    this.name = name;
    return this;
  }

  /**
   * Name of the site should contain 1 to 64 characters.
   * @return name
  */
  @ApiModelProperty(value = "Name of the site should contain 1 to 64 characters.")


  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public SiteTemplateSummaryVo status(Integer status) {
    this.status = status;
    return this;
  }

  /**
   * Site template sync sites status.
   * @return status
  */
  @ApiModelProperty(value = "Site template sync sites status.")


  public Integer getStatus() {
    return status;
  }

  public void setStatus(Integer status) {
    this.status = status;
  }

  public SiteTemplateSummaryVo bindSiteNum(Long bindSiteNum) {
    this.bindSiteNum = bindSiteNum;
    return this;
  }

  /**
   * The number of sites to which the template is bound.
   * @return bindSiteNum
  */
  @ApiModelProperty(value = "The number of sites to which the template is bound.")


  public Long getBindSiteNum() {
    return bindSiteNum;
  }

  public void setBindSiteNum(Long bindSiteNum) {
    this.bindSiteNum = bindSiteNum;
  }

  public SiteTemplateSummaryVo category(String category) {
    this.category = category;
    return this;
  }

  /**
   * The category of the site template.
   * @return category
  */
  @ApiModelProperty(value = "The category of the site template.")


  public String getCategory() {
    return category;
  }

  public void setCategory(String category) {
    this.category = category;
  }

  public SiteTemplateSummaryVo settings(List<String> settings) {
    this.settings = settings;
    return this;
  }

  public SiteTemplateSummaryVo addSettingsItem(String settingsItem) {
    if (this.settings == null) {
      this.settings = new ArrayList<>();
    }
    this.settings.add(settingsItem);
    return this;
  }

  /**
   * The settings of site template seleted.
   * @return settings
  */
  @ApiModelProperty(value = "The settings of site template seleted.")


  public List<String> getSettings() {
    return settings;
  }

  public void setSettings(List<String> settings) {
    this.settings = settings;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    SiteTemplateSummaryVo siteTemplateSummaryVo = (SiteTemplateSummaryVo) o;
    return Objects.equals(this.id, siteTemplateSummaryVo.id) &&
        Objects.equals(this.omadacId, siteTemplateSummaryVo.omadacId) &&
        Objects.equals(this.name, siteTemplateSummaryVo.name) &&
        Objects.equals(this.status, siteTemplateSummaryVo.status) &&
        Objects.equals(this.bindSiteNum, siteTemplateSummaryVo.bindSiteNum) &&
        Objects.equals(this.category, siteTemplateSummaryVo.category) &&
        Objects.equals(this.settings, siteTemplateSummaryVo.settings);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, omadacId, name, status, bindSiteNum, category, settings);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class SiteTemplateSummaryVo {\n");
    
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    omadacId: ").append(toIndentedString(omadacId)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    status: ").append(toIndentedString(status)).append("\n");
    sb.append("    bindSiteNum: ").append(toIndentedString(bindSiteNum)).append("\n");
    sb.append("    category: ").append(toIndentedString(category)).append("\n");
    sb.append("    settings: ").append(toIndentedString(settings)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

